package com.engine.salary.mapper.salarysob;

import com.engine.salary.entity.salarysob.po.SalarySobBackItemPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

/**
 * @author Harryxzy
 * @date 2022/11/15 16:31
 * @description
 */
public interface SalarySobBackItemMapper {

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<SalarySobBackItemPO> listAll();

    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<SalarySobBackItemPO> listSome(SalarySobBackItemPO salarySobBackItem);


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    SalarySobBackItemPO getById(Long id);

    /**
     * 新增，忽略null字段
     *
     * @param salarySobBackItem 新增的记录
     * @return 返回影响行数
     */
    int insertIgnoreNull(SalarySobBackItemPO salarySobBackItem);

    /**
     * 修改，修改所有字段
     *
     * @param salarySobBackItem 修改的记录
     * @return 返回影响行数
     */
    int update(SalarySobBackItemPO salarySobBackItem);

    /**
     * 修改，忽略null字段
     *
     * @param salarySobBackItem 修改的记录
     * @return 返回影响行数
     */
    int updateIgnoreNull(SalarySobBackItemPO salarySobBackItem);

    /**
     * 删除记录
     *
     * @param salarySobBackItem 待删除的记录
     * @return 返回影响行数
     */
    int delete(SalarySobBackItemPO salarySobBackItem);

    void batchInsert(@Param("collection") List<SalarySobBackItemPO> needInsertSalarySobBackItems);

    /**
     * @description 根据薪资账套获取回算薪资项目数
     * @return Long
     * @author Harryxzy
     * @date 2022/11/18 13:57
     */
    Long countBySalarySobIdIn(@Param("salarySobIdCollection")Collection<Long> salarySobIdCollection);

    /**
     * @description 根据薪资账套删除
     * @return void
     * @author Harryxzy
     * @date 2022/11/22 14:17
     */
    int deleteBySalarySobIds( @Param("salarySobIdList") Collection<Long> salarySobIdList);
}
